function [ sol ] = NFSEP_mtx_prod_vec_Lambda(vec, EigDecompDoubCurl_cell, diag_B_eps, ...
        fun_mtx_TH_prod_vec, fun_mtx_T_prod_vec)
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here

n    = length(vec);
n2   = n / 2;

tmp_vec = vec./[ EigDecompDoubCurl_cell.inv_Lambda_q_s; EigDecompDoubCurl_cell.inv_Lambda_q_s ];
tmp1    = EigDecompDoubCurl_cell.Lambda_Qr * tmp_vec; %Lambda_Q1 * vec_t(1:n2,1) + Lambda_Q2 * vec_t(n2+1:n,1);

tmp1(     1:n2,  1) = fun_mtx_T_prod_vec(tmp1(1:n2,1));
tmp1(  n2+1:2*n2,1) = fun_mtx_T_prod_vec(tmp1(n2+1:2*n2,1));
tmp1(2*n2+1:3*n2,1) = fun_mtx_T_prod_vec(tmp1(2*n2+1:3*n2,1));

tmp1 = tmp1./diag_B_eps;

tmp1(     1:n2,  1) = fun_mtx_TH_prod_vec(tmp1(1:n2,1));
tmp1(  n2+1:2*n2,1) = fun_mtx_TH_prod_vec(tmp1(n2+1:2*n2,1));
tmp1(2*n2+1:3*n2,1) = fun_mtx_TH_prod_vec(tmp1(2*n2+1:3*n2,1));

sol = EigDecompDoubCurl_cell.Lambda_Qr' * tmp1;
sol = sol./[ EigDecompDoubCurl_cell.inv_Lambda_q_s; EigDecompDoubCurl_cell.inv_Lambda_q_s ];

end

