function [ prec_M ] = Coefficient_mtx( par, sgm )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

[i_idx_K, j_idx_K, val_K]    = find(par.mtx_K);
[i_idx_M, j_idx_M, val_M]    = find(par.mtx_M);
[i_idx_M1, j_idx_M1, val_M1] = find(par.mtx_M1);
[i_idx_F, j_idx_F, val_F]    = find(par.mtx_F);
[i_idx_F1, j_idx_F1, val_F1] = find(par.mtx_F1);
[i_idx_E, j_idx_E, val_E]    = find(par.mtx_E);
[i_idx_G, j_idx_G, val_G]    = find(par.mtx_G);

n     = size(par.mtx_K,1);
m     = size(par.mtx_F,2);
                        
        % case 1
i_idx_prec_M = [ i_idx_M; n+j_idx_F; i_idx_F; n+i_idx_G; n+m+i_idx_M; 2*n+m+j_idx_F; n+m+i_idx_F; ... 
    2*n+m+i_idx_G; i_idx_K; n+j_idx_E; n+m+i_idx_M1; 2*n+m+j_idx_F1; 2*n+2*m+i_idx_K; ...
    2*n+2*m+i_idx_E ];
j_idx_prec_M = [ j_idx_M; i_idx_F; n+j_idx_F; n+j_idx_G; n+m+j_idx_M; n+m+i_idx_F; 2*n+m+j_idx_F; ...
    2*n+m+j_idx_G; 2*n+2*m+j_idx_K; 2*n+2*m+i_idx_E; 2*n+2*m+j_idx_M1; 2*n+2*m+i_idx_F1; ...
    j_idx_K; n+j_idx_E ];
val_prec_M   = [ val_M; val_F; val_F; val_G; val_M; val_F; val_F; val_G; -val_K; ...
    -val_E; -val_M1; -val_F1; val_K; val_E ]; 
prec_M1      = sparse(i_idx_prec_M, j_idx_prec_M, val_prec_M, 3*n+2*m, 3*n+2*m);
       
[i_idx_K, j_idx_K, val_K]    = find(par.mu * par.mtx_M1 - par.mtx_K);
[i_idx_E, j_idx_E, val_E]    = find(par.mu * par.mtx_F1 - par.mtx_E);

i_idx_prec_M = [ 2*n+2*m+i_idx_M1; 2*n+2*m+i_idx_F1; 2*n+2*m+i_idx_K; 2*n+2*m+i_idx_E; ...
    2*n+2*m+i_idx_K];
j_idx_prec_M = [ j_idx_M1; n+j_idx_F1; n+m+j_idx_K; 2*n+m+j_idx_E; 2*n+2*m+j_idx_K ];
val_prec_M   = [ -val_M1; -val_F1; val_K; val_E; val_K ]; 
prec_M2      = sparse(i_idx_prec_M, j_idx_prec_M, val_prec_M, 3*n+2*m, 3*n+2*m);

prec_M       = prec_M1 + sgm * prec_M2;

end

