function [ sol ] = NFSEP_invert_LS( rhs, diag_B_eps, EigDecompDoubCurl_cell, ...
    fun_mtx_TH_prod_vec, fun_mtx_T_prod_vec, LSopt )
%UNTITLED6 Summary of this function goes here
%   Detailed explanation goes here

maxit   = 1e4;
tol     = LSopt.tol;

tmp_rhs = [ EigDecompDoubCurl_cell.inv_Lambda_q_s; EigDecompDoubCurl_cell.inv_Lambda_q_s ].*rhs;

[vec_t1,flag,relres,iter] = pcg(@(vec)NFSEP_mtx_prod_vec(vec, EigDecompDoubCurl_cell, diag_B_eps, ...
        fun_mtx_TH_prod_vec, fun_mtx_T_prod_vec), tmp_rhs, tol, maxit);
 
if ( strcmp(LSopt.infoConvBeh, 'YES') || strcmp(LSopt.infoConvBeh, 'yes') )
    fprintf('Iteration number of CG is %4.0f with flag = %2.0f and relres = %11.4e; \n', ...
          iter, flag, relres); 
end

sol = [ EigDecompDoubCurl_cell.inv_Lambda_q_s; EigDecompDoubCurl_cell.inv_Lambda_q_s ].*vec_t1;
                        
end

